/*
 *  ExcelDDEHotConnection. 
 * 
 *  DDEML. 
 * 
 * :     DDEML
 * 
 *  :  
 * 
 *    .NET  PFSoft.
 * 
 * PFSoft, 
 *  
 * 
 * 
 * E-mail: rovshan_gasanoff@psoft.com
 * WEB   : www.pfsoft.com
 * 
 * 3  2005
 * 
 *         "     MS Excel  DDE "
 *           ,     
 * .            .
 *       ,          
 * .
 * 
 * 
 */

using System;
using System.Runtime.InteropServices;
using System.Text;


namespace PFSoft.ExcelDDE
{

	/// <summary>
	///     DDE
	/// </summary>
	internal delegate IntPtr DDECallBackDelegate(
	uint wType,             //  
	uint wFmt,              //  
	IntPtr hConv,           //  
	IntPtr hsz1,            //   (  ,  )
	IntPtr hsz2,            //   (  ,  )
	IntPtr hData,           //    ,   
	uint dwData1,           //   (    )
	uint dwData2            //   (    )
	);          


	/// <summary>
	///  -    .NET    DDEML
	/// </summary>
	internal sealed class DDEML
	{
		#region // ,    DDEML (  )

		//     .   
		//   
		internal const uint XCLASS_BOOL			= 0x1000;
		internal const uint XCLASS_FLAGS		= 0x4000;
		internal const uint XCLASS_NOTIFICATION	= 0x8000;

		//     ,     
		//    ,    ( ) .
		//      null
		internal const uint DDE_FACK			= 0x8000;
		// ,      ANSI
		internal const int  CP_WINANSI			= 1004;
		// ,      Unicode
		internal const int  CP_WINUNICODE		= 1200;
		// ,    
		internal const uint CF_TEXT				= 1;

		//  .    ,   
		//    
		internal const uint XTYP_ADVSTART		= (0x0030 | XCLASS_BOOL);
		internal const uint XTYP_ADVSTOP		= (0x0040 | XCLASS_NOTIFICATION);
		internal const uint XTYP_ADVDATA		= (0x0010 | XCLASS_FLAGS);

		#endregion

		#region //      DDE


		/// <summary>
		///   DdeInitialize.     
		/// DDEML    ,   DDEML
		///    : 
		/// pidInst       - ,      . 
		///                       
		/// pfnCallback   -   -    .
		///                        
		///                  DDECallBackDelegate. !    
		///                     ,     
		///                        .   
		///                       ,
		///                         ,     . 
		///                      DDEML    
		///                 ,         
		///                  .   .  .
		/// afCmd         -    ,     DDE
		/// ulRes         - .    .
		///                        
		/// </summary>
		[DllImport("user32.dll", EntryPoint="DdeInitialize", CharSet=CharSet.Ansi)]
		internal static extern uint DdeInitialize(
			ref uint pidInst, DDECallBackDelegate pfnCallback, uint afCmd, uint ulRes);

		/// <summary>
		///   DdeUninitialize
		///     DDEML
		///      ,   
		///  .  true    ,  false -   .
		/// </summary>
		[DllImport("user32.dll", EntryPoint="DdeUninitialize", CharSet=CharSet.Ansi)]
		internal static extern bool DdeUninitialize(uint idInst);

		/// <summary>
		///   DdeCreateStringHandle.
		///        DDEML.
		///     :
		/// idInst       -  ,       DDEML
		/// psz          - .    ,    - .NET
		///                     .
		/// iCodePage    -  .       CP_WINANSI
		///   .   ,    ,
		///   IntPtr.Zero
		/// </summary>
		[DllImport("user32.dll", EntryPoint="DdeCreateStringHandle", CharSet=CharSet.Ansi)]
		internal static extern IntPtr DdeCreateStringHandle(uint idInst, string psz, int iCodePage);

		/// <summary>
		///   DdeFreeStringHandle
		///   .    :
		/// idInst     -  ,       DDEML
		/// hsz        -  ,      DdeCreateStringHandle
		///  true     false   .
		/// </summary>
		[DllImport("user32.dll", EntryPoint="DdeFreeStringHandle", CharSet=CharSet.Ansi)]
		internal static extern bool DdeFreeStringHandle(uint idInst, IntPtr hsz);


		/// <summary>
		///   DdeConnect
		///   .    :
		/// idInst      -  ,       DDEML
		/// hszService  -   .      , 
		///                  DdeCreateStringHandle
		/// hszTopic    -   .      , 
		///                  DdeCreateStringHandle
		/// pCC         -    CONVCONTEXT,     
		///                 null
		///         0 -   
		/// </summary>
		[DllImport("user32.dll", EntryPoint="DdeConnect", CharSet=CharSet.Ansi)]
		internal static extern IntPtr DdeConnect(uint idInst, IntPtr hszService, IntPtr hszTopic, IntPtr pCC);

		/// <summary>
		///   DdeDisconnect
		///  .       
		///  true     ,  false -   
		/// </summary>
		/// <param name="hConv"></param>
		/// <returns></returns>
		[DllImport("user32.dll", EntryPoint="DdeDisconnect", CharSet=CharSet.Ansi)]
		internal static extern bool DdeDisconnect(IntPtr hConv);

		/// <summary>
		///   DdeClientTransaction.
		///   DDE.      :
		/// pData             -   ,  
		/// cbData            -   
		/// hConv             -   ,    DdeConnect
		/// hszItem           -   ,    - .   
		///                   -  ,    DdeCreateStringHandle
		/// uFmt              -  .    Excel   CF_TEXT(1)
		/// uType             -  .    .  
		///                          XTYP_ADVSTART -  
		///                         XTYP_ADVSTOP -       
		/// dwTimeout         - -    -     
		///                          0,     
		/// pdwResult         -    ,       . 
		///                          .
		///   ,  IntPtr.Zero,      ,   
		///      , (    1)   .                   
		/// </summary>
		[DllImport("user32.dll", EntryPoint="DdeClientTransaction", CharSet=CharSet.Ansi)]
		internal static extern IntPtr DdeClientTransaction(
			IntPtr pData, uint cbData, IntPtr hConv, IntPtr hszItem, uint uFmt, uint uType, uint dwTimeout, ref uint pdwResult);

		/// <summary>
		///   DdeGetData
		///      .    :
		/// hData          -  ,   
		/// pDst           -     ,      .
		///                       null,      
		///                     ,    hData
		/// cbMax          -    
		/// cbOff          -      .
		///  ,     pDst    ,       ,
		///    hData.        ,   hData  ,
		///    cbMax. (   )
		/// </summary>
		[DllImport("user32.dll", EntryPoint="DdeGetData", CharSet=CharSet.Ansi)]
		internal static extern uint DdeGetData(IntPtr hData, [Out] byte[] pDst, uint cbMax, uint cbOff);

		/// <summary>
		///   DdeQueryString. 
		///    DDEML    .    :
		/// idInst         -  ,       DDEML
		/// hsz            -  ,    DDEML
		/// psz            - ,     .   . 
		/// cchMax         -    .   (ANSI  UNICODE)   
		/// iCodePage      -   ,     . 
		///                   CP_WINANSI  CP_WINUNICODE.
		///       ,    psz.   null,
		///        (     iCodePage).   
		///    ,    (  ccMax     -  
		///   )
		/// </summary>
		[DllImport("user32.dll", EntryPoint="DdeQueryString", CharSet=CharSet.Ansi)]
		internal static extern uint DdeQueryString(uint idInst, IntPtr hsz, StringBuilder psz, uint cchMax, int iCodePage);
		
		#endregion
		
	}

} 
