/*
 *  ExcelDDEHotConnection. 
 * 
 *  TopicDescriptor. 
 * :   - +
 * 
 *  TopicDescriptorCollection. 
 * :    - +
 * 
 *  :  
 * 
 *    .NET  PFSoft.
 * 
 * 
 * PFSoft, 
 *  
 * 
 * 
 * E-mail: rovshan_gasanoff@psoft.com
 * WEB   : www.pfsoft.com
 * 
 * 3  2005
 * 
 *         "     MS Excel  DDE "
 *           ,     
 * .            .
 *       ,          
 * .
 * 
 * 
 */

using System;
using System.Collections;
using System.Runtime.InteropServices;

namespace PFSoft.ExcelDDE
{


	#region    - +

	/// <summary>
	///    - +
	/// </summary>
	public class TopicDescriptor:IDisposable
	{
		#region //   
		private string _Book = "1.xls";
		/// <summary>
		///  
		/// </summary>
		public string Book
		{
			get { return _Book; }
		}

		private string _Sheet = "1";
		/// <summary>
		///  
		/// </summary>
		public string Sheet
		{
			get { return _Sheet; }
		}
		#endregion

		#region //   

		private Hashtable _Table = new Hashtable();
		private ArrayList _List = new ArrayList();

		/// <summary>
		///        row      col
		/// </summary>
		public Result Add(int row, int col)
		{
			ItemDescriptor descriptor = new ItemDescriptor(row, col);
			return Add(descriptor);
		}

		/// <summary>
		///      
		/// </summary>
		/// <param name="descriptor"></param>
		/// <returns></returns>
		public Result Add(ItemDescriptor descriptor)
		{
			string szItem = descriptor.Item;
			if(!_Table.ContainsKey(szItem))
			{
				//   
				IntPtr hszItem = DDEML.DdeCreateStringHandle(_idInst, szItem, DDEML.CP_WINANSI);
				//   
				uint pwdResult = 0;
				IntPtr hData = DDEML.DdeClientTransaction((IntPtr)null, 0, hConv, hszItem, DDEML.CF_TEXT, DDEML.XTYP_ADVSTART, 1000, ref pwdResult);
				if(hData!=IntPtr.Zero)
				{
					//   
					_Table.Add(szItem, descriptor);
					_List.Add(descriptor);
				}
				//   
				DDEML.DdeFreeStringHandle(_idInst, hszItem);
				//  
				return (hData!=IntPtr.Zero) ? Result.OK : Result.SubscribeError;
			}
			else
			{
				//       
				return Result.AlreadyExists;
			}
		}

		/// <summary>
		///     ()
		/// </summary>
		public Result Remove(int row, int col)
		{
			ItemDescriptor descriptor = this[row, col];
			if(descriptor!=null)
				return Remove(descriptor);
			else
				return Result.NonExistingItem;
		}

		/// <summary>
		///   ,  descriptor
		/// </summary>
		/// <param name="descriptor"></param>
		/// <returns></returns>
		public Result Remove(ItemDescriptor descriptor)
		{
			string szItem = descriptor.Item;
			if(_Table.ContainsKey(szItem))
			{
				//  
				IntPtr hszItem = DDEML.DdeCreateStringHandle(_idInst, szItem, DDEML.CP_WINANSI);
				//    
				uint pwdResult = 0;
				IntPtr hData = DDEML.DdeClientTransaction((IntPtr)null, 0, hConv, hszItem, DDEML.CF_TEXT, DDEML.XTYP_ADVSTOP, 1000, ref pwdResult);
				//   
				DDEML.DdeFreeStringHandle(_idInst, hszItem);
				//   
				_Table.Remove(szItem);
				_List.Remove(descriptor);
				//  
				return (hData!=IntPtr.Zero) ? Result.OK : Result.UnsubscribeError;
			}
			else
				//    
				return Result.NonExistingItem;
		}

		/// <summary>
		///     
		/// </summary>
		public void Clear()
		{
			for(int i = 0; i<_List.Count;)
			{
				ItemDescriptor descriptor = this[i];
				Remove(descriptor);
			}
		}

		/// <summary>
		///    
		/// </summary>
		public int Count
		{
			get { return _Table.Count; }
		}

		/// <summary>
		///        
		/// </summary>
		public ItemDescriptor this[int row, int col]
		{
			get { return (ItemDescriptor)_Table["R"+row.ToString()+"C"+col.ToString()]; }
		}

		/// <summary>
		///      
		/// </summary>
		internal ItemDescriptor this[string item]
		{
			get {return (ItemDescriptor)_Table[item]; }
		}

		/// <summary>
		///        
		/// </summary>
		public ItemDescriptor this[int index]
		{
			get { return (ItemDescriptor)_List[index]; }
		}

		#endregion

		#region    DDE 

		private uint _idInst = 0;
		/// <summary>
		///  ,    DDEML
		/// </summary>
		internal uint idInst
		{
			get { return _idInst;  }
			set { _idInst = value; }
		}

		private IntPtr _hConv = IntPtr.Zero;
		/// <summary>
		///  ,    DDEML
		/// </summary>
		internal IntPtr hConv
		{
			get { return _hConv;  }
			set { _hConv = value; }
		}


		/// <summary>
		///   
		/// </summary>
		public string Topic
		{
			get { return "[" + _Book + "]" + _Sheet; }
		}

		#endregion

		#region   

		public TopicDescriptor(string book, string sheet)
		{
			_Book = book;
			_Sheet = sheet;
		}

		public void Dispose()
		{
			Clear();
		}

		#endregion
	}

	#endregion

	#region  .

	/// <summary>
	///  .
	/// </summary>
	public class TopicDescriptorCollection:IDisposable
	{
		private Hashtable _Table = new Hashtable();
		private ArrayList _List = new ArrayList();

		/// <summary>
		///      
		///   DDEML
		/// </summary>
		public Result Add(string book, string sheet)
		{
			TopicDescriptor descriptor = new TopicDescriptor(book, sheet);
			return Add(descriptor);
		}
		/// <summary>
		///      
		///   DDEML
		/// </summary>
		public Result Add(TopicDescriptor descriptor)
		{
			//      
			string szTopic = descriptor.Topic;
			if(!_Table.ContainsKey(szTopic))
			{
				//   
				IntPtr hszService = DDEML.DdeCreateStringHandle(_idInst, "EXCEL", DDEML.CP_WINANSI);
				//   
				IntPtr hszTopic = DDEML.DdeCreateStringHandle(_idInst, szTopic, DDEML.CP_WINANSI);
				//   
				IntPtr hConv = DDEML.DdeConnect(_idInst, hszService, hszTopic, (IntPtr)null);
				//  
				if(hConv!=IntPtr.Zero)
				{
					//     
					descriptor.idInst = _idInst;
					descriptor.hConv = hConv;
					//    
					_Table.Add(szTopic, descriptor);
					_List.Add(descriptor);
				}
				//   
				DDEML.DdeFreeStringHandle(_idInst, hszService);
				DDEML.DdeFreeStringHandle(_idInst, hszTopic);
				//   -   
				return Result.OK;
			}
			else
				//   
				return Result.AlreadyExists;
		}

		/// <summary>
		///    
		/// </summary>
		/// <param name="descriptor"></param>
		/// <returns></returns>
		public Result Remove(TopicDescriptor descriptor)
		{
			//      
			string szTopic = descriptor.Topic;
			if(_Table.ContainsKey(szTopic))
			{
				//  
				descriptor.Dispose();
				//  
				IntPtr hConv = descriptor.hConv;
				DDEML.DdeDisconnect(hConv);
				//    
				_Table.Remove(szTopic);
				_List.Remove(descriptor);
				//  
				return Result.OK;
			}
			else
				//   
				return Result.NonExistingItem;
		}
		/// <summary>
		///    
		/// </summary>
		/// <param name="book"></param>
		/// <param name="sheet"></param>
		/// <returns></returns>
		public Result Remove(string book, string sheet)
		{
			TopicDescriptor descriptor = this[book, sheet];
			if(descriptor!=null)
				return Remove(descriptor);
			else
				return Result.NonExistingItem;
		}

		/// <summary>
		///     
		/// </summary>
		public void Clear()
		{
			for(int i = 0; i<_List.Count; )
			{
				TopicDescriptor descriptor = (TopicDescriptor)_List[i];
				Remove(descriptor);
			}
		}

		/// <summary>
		///   
		/// </summary>
		public int Count
		{
			get { return _Table.Count; }
		}

		/// <summary>
		///      
		/// </summary>
		public TopicDescriptor this[string book, string sheet]
		{
			get { return (TopicDescriptor)_Table["[" + book + "]" + sheet]; }
		}

		/// <summary>
		///    
		/// </summary>
		public TopicDescriptor this[string topic]
		{
			get { return (TopicDescriptor)_Table[topic]; }
		}

		/// <summary>
		///      
		/// </summary>
		public TopicDescriptor this[int index]
		{
			get { return (TopicDescriptor)_List[index]; }
		}

		private uint _idInst = 0;
		/// <summary>
		///  ,    DDEML
		///    
		/// </summary>
		internal uint idInst
		{
			get { return _idInst;  }
			set { _idInst = value; }
		}

		/// <summary>
		///    
		/// </summary>
		private TopicDescriptorCollection(){}

		/// <summary>
		///  .
		/// </summary>
		/// <param name="id_inst"></param>
		public TopicDescriptorCollection(uint id_inst)
		{
			_Table = new Hashtable();
		    _List = new ArrayList();
			_idInst = id_inst;
		}
		
		#region IDisposable Members

		public void Dispose()
		{
			Clear();
		}

		#endregion

	}

	#endregion

}
